*** a/src/backend/commands/tablecmds.c
--- b/src/backend/commands/tablecmds.c
***************
*** 4261,4266 **** ATExecAddColumn(List **wqueue, AlteredTableInfo *tab, Relation rel,
--- 4661,4677 ----
  			simple_heap_update(attrdesc, &tuple->t_self, tuple);
  			CatalogUpdateIndexes(attrdesc, tuple);
  
+ 			/*
+ 			 * If the new column is marked NOT NULL, we need to increment
+ 			 * inhcount to an existing NOT NULL constraint in the child, or
+ 			 * create a new one if it doesn't exist.  Skip this for the OID
+ 			 * column.
+ 			 */
+ 			if (colDef->is_not_null && !isOid)
+ 				CreateOrAdjustNotNullConstraint(rel, childatt->attnum,
+ 												NameStr(childatt->attname),
+ 												1, 0);
+ 
  			heap_freetuple(tuple);
  
  			/* Inform the user about the merge */
***************
*** 4328,4334 **** ATExecAddColumn(List **wqueue, AlteredTableInfo *tab, Relation rel,
  	attribute.attndims = list_length(colDef->typeName->arrayBounds);
  	attribute.attstorage = tform->typstorage;
  	attribute.attalign = tform->typalign;
! 	attribute.attnotnull = colDef->is_not_null;
  	attribute.atthasdef = false;
  	attribute.attisdropped = false;
  	attribute.attislocal = colDef->is_local;
--- 4739,4745 ----
  	attribute.attndims = list_length(colDef->typeName->arrayBounds);
  	attribute.attstorage = tform->typstorage;
  	attribute.attalign = tform->typalign;
! 	attribute.attnotnull = colDef->is_not_null | colDef->is_primary_key;
  	attribute.atthasdef = false;
  	attribute.attisdropped = false;
  	attribute.attislocal = colDef->is_local;
***************
*** 4366,4371 **** ATExecAddColumn(List **wqueue, AlteredTableInfo *tab, Relation rel,
--- 4777,4784 ----
  	/* Make the attribute's catalog entry visible */
  	CommandCounterIncrement();
  
+ 	need_final_cci = false;
+ 
  	/*
  	 * Store the DEFAULT, if any, in the catalogs
  	 */
***************
*** 4388,4398 **** ATExecAddColumn(List **wqueue, AlteredTableInfo *tab, Relation rel,
  		 */
  		AddRelationNewConstraints(rel, list_make1(rawEnt), NIL, false, true);
  
! 		/* Make the additional catalog changes visible */
! 		CommandCounterIncrement();
  	}
  
  	/*
  	 * Tell Phase 3 to fill in the default expression, if there is one.
  	 *
  	 * If there is no default, Phase 3 doesn't have to do anything, because
--- 4801,4826 ----
  		 */
  		AddRelationNewConstraints(rel, list_make1(rawEnt), NIL, false, true);
  
! 		need_final_cci = true;
! 	}
! 
! 	/* Finally, store the NOT NULL constraint, if necessary, except for OID */
! 	if (colDef->is_not_null && !isOid)
! 	{
! 		Constraint	*constraint = locate_notnull_constraint(colDef);
! 
! 		CreateNotNullConstraint(rel, attribute.attnum, constraint->conname,
! 								colDef->inhcount, colDef->is_local);
! 		need_final_cci = true;
  	}
  
  	/*
+ 	 * Make new defaults and NOT NULL constraints visible.
+ 	 */
+ 	if (need_final_cci)
+ 		CommandCounterIncrement();
+ 
+ 	/*
  	 * Tell Phase 3 to fill in the default expression, if there is one.
  	 *
  	 * If there is no default, Phase 3 doesn't have to do anything, because
***************
*** 4460,4471 **** ATExecAddColumn(List **wqueue, AlteredTableInfo *tab, Relation rel,
  		}
  
  		/*
! 		 * If the new column is NOT NULL, tell Phase 3 it needs to test that.
! 		 * (Note we don't do this for an OID column.  OID will be marked not
! 		 * null, but since it's filled specially, there's no need to test
! 		 * anything.)
  		 */
! 		tab->new_notnull |= colDef->is_not_null;
  	}
  
  	/*
--- 4888,4899 ----
  		}
  
  		/*
! 		 * If the new column is either NOT NULL or primary key, tell Phase 3 it
! 		 * needs to test that.  (Note we don't do this for an OID column.  OID
! 		 * will be marked not null, but since it's filled specially, there's no
! 		 * need to test anything.)
  		 */
! 		tab->new_notnull |= (colDef->is_not_null | colDef->is_primary_key);
  	}
  
  	/*
***************
*** 4567,4707 **** add_column_collation_dependency(Oid relid, int32 attnum, Oid collid)
  }
  
  /*
!  * ALTER TABLE SET WITH OIDS
!  *
!  * Basically this is an ADD COLUMN for the special OID column.	We have
!  * to cons up a ColumnDef node because the ADD COLUMN code needs one.
   */
! static void
! ATPrepAddOids(List **wqueue, Relation rel, bool recurse, AlterTableCmd *cmd, LOCKMODE lockmode)
  {
! 	/* If we're recursing to a child table, the ColumnDef is already set up */
! 	if (cmd->def == NULL)
  	{
! 		ColumnDef  *cdef = makeNode(ColumnDef);
  
! 		cdef->colname = pstrdup("oid");
! 		cdef->typeName = makeTypeNameFromOid(OIDOID, -1);
! 		cdef->inhcount = 0;
! 		cdef->is_local = true;
! 		cdef->is_not_null = true;
! 		cdef->storage = 0;
! 		cmd->def = (Node *) cdef;
  	}
! 	ATPrepAddColumn(wqueue, rel, recurse, false, cmd, lockmode);
  
! 	if (recurse)
! 		cmd->subtype = AT_AddOidsRecurse;
  }
  
  /*
!  * ALTER TABLE ALTER COLUMN DROP NOT NULL
   */
! static void
! ATExecDropNotNull(Relation rel, const char *colName, LOCKMODE lockmode)
  {
- 	HeapTuple	tuple;
- 	AttrNumber	attnum;
- 	Relation	attr_rel;
- 	List	   *indexoidlist;
- 	ListCell   *indexoidscan;
- 
  	/*
! 	 * lookup the attribute
! 	 */
! 	attr_rel = heap_open(AttributeRelationId, RowExclusiveLock);
  
! 	tuple = SearchSysCacheCopyAttName(RelationGetRelid(rel), colName);
  
! 	if (!HeapTupleIsValid(tuple))
! 		ereport(ERROR,
! 				(errcode(ERRCODE_UNDEFINED_COLUMN),
! 				 errmsg("column \"%s\" of relation \"%s\" does not exist",
! 						colName, RelationGetRelationName(rel))));
  
! 	attnum = ((Form_pg_attribute) GETSTRUCT(tuple))->attnum;
  
! 	/* Prevent them from altering a system attribute */
! 	if (attnum <= 0)
! 		ereport(ERROR,
! 				(errcode(ERRCODE_FEATURE_NOT_SUPPORTED),
! 				 errmsg("cannot alter system column \"%s\"",
! 						colName)));
  
! 	/*
! 	 * Check that the attribute is not in a primary key
! 	 */
  
! 	/* Loop over all indexes on the relation */
! 	indexoidlist = RelationGetIndexList(rel);
  
! 	foreach(indexoidscan, indexoidlist)
  	{
! 		Oid			indexoid = lfirst_oid(indexoidscan);
! 		HeapTuple	indexTuple;
! 		Form_pg_index indexStruct;
! 		int			i;
  
! 		indexTuple = SearchSysCache1(INDEXRELID, ObjectIdGetDatum(indexoid));
! 		if (!HeapTupleIsValid(indexTuple))
! 			elog(ERROR, "cache lookup failed for index %u", indexoid);
! 		indexStruct = (Form_pg_index) GETSTRUCT(indexTuple);
  
! 		/* If the index is not a primary key, skip the check */
! 		if (indexStruct->indisprimary)
! 		{
! 			/*
! 			 * Loop over each attribute in the primary key and see if it
! 			 * matches the to-be-altered attribute
! 			 */
! 			for (i = 0; i < indexStruct->indnatts; i++)
! 			{
! 				if (indexStruct->indkey.values[i] == attnum)
! 					ereport(ERROR,
! 							(errcode(ERRCODE_INVALID_TABLE_DEFINITION),
! 							 errmsg("column \"%s\" is in a primary key",
! 									colName)));
! 			}
! 		}
  
! 		ReleaseSysCache(indexTuple);
  	}
  
! 	list_free(indexoidlist);
  
! 	/*
! 	 * Okay, actually perform the catalog change ... if needed
! 	 */
! 	if (((Form_pg_attribute) GETSTRUCT(tuple))->attnotnull)
! 	{
! 		((Form_pg_attribute) GETSTRUCT(tuple))->attnotnull = FALSE;
  
! 		simple_heap_update(attr_rel, &tuple->t_self, tuple);
  
! 		/* keep the system catalog indexes current */
! 		CatalogUpdateIndexes(attr_rel, tuple);
  	}
  
! 	heap_close(attr_rel, RowExclusiveLock);
  }
  
  /*
!  * ALTER TABLE ALTER COLUMN SET NOT NULL
   */
  static void
! ATExecSetNotNull(AlteredTableInfo *tab, Relation rel,
! 				 const char *colName, LOCKMODE lockmode)
  {
  	HeapTuple	tuple;
  	AttrNumber	attnum;
  	Relation	attr_rel;
  
  	/*
! 	 * lookup the attribute
  	 */
  	attr_rel = heap_open(AttributeRelationId, RowExclusiveLock);
  
! 	tuple = SearchSysCacheCopyAttName(RelationGetRelid(rel), colName);
  
  	if (!HeapTupleIsValid(tuple))
  		ereport(ERROR,
--- 4995,5536 ----
  }
  
  /*
!  * Create a NOT NULL pg_constraint entry for the given column of the
!  * given name.  If the name is NULL, a new one is generated.
   */
! void
! CreateNotNullConstraint(Relation rel, AttrNumber attnum, char *constr_name,
! 						int inhcount, bool islocal)
  {
! 	NotNullConstraint	constraint;
! 
! 	Assert(AttrNumberIsForUserDefinedAttr(attnum));
! 
! 	if (constr_name)
! 		constraint.conname = pstrdup(constr_name);
! 	else
  	{
! 		TupleDesc	tupdesc = RelationGetDescr(rel);
! 		char	   *attname = NameStr(tupdesc->attrs[attnum - 1]->attname);
  
! 		constraint.conname =
! 			ChooseConstraintName(RelationGetRelationName(rel),
! 								 attname,
! 								 "not_null", RelationGetNamespace(rel),
! 								 NIL);
  	}
! 	/* attname is not used here */
! 	constraint.attnum = attnum;
! 	constraint.is_local = islocal;
! 	constraint.inhcount = islocal ? 0 : 1;
  
! 	StoreNotNullConstraint(RelationGetRelid(rel), RelationGetNamespace(rel),
! 						   &constraint);
! 	pfree(constraint.conname);
  }
  
  /*
!  * Stores a NOT NULL constraint of a column into pg_constraint.
   */
! void
! StoreNotNullConstraint(Oid relid, Oid nspid, NotNullConstraint *constraint)
  {
  	/*
! 	 * Store the constraint. Reflect conislocal and coninhcount to
! 	 * match the same values as the attached column.
! 	 */
! 	CreateConstraintEntry(constraint->conname,
! 						  nspid,
! 						  CONSTRAINT_NOTNULL,
! 						  false,
! 						  false,
! 						  true,
! 						  relid,
! 						  &(constraint->attnum),
! 						  1,
! 						  InvalidOid,
! 						  InvalidOid,
! 						  InvalidOid,
! 						  NULL,
! 						  InvalidOid,
! 						  InvalidOid,
! 						  InvalidOid,
! 						  0,
! 						  ' ',
! 						  ' ',
! 						  ' ',
! 						  NULL,
! 						  NULL,
! 						  NULL,
! 						  NULL,
! 						  constraint->is_local,
! 						  constraint->inhcount);
! }
  
! /*
!  * get_constraint_singlecol_attno
!  *
!  * Get the column number that this pg_constraint tuple is for.  Note that
!  * this can only be useful for NOT NULL constraints, because other types
!  * might have more than one key column, and this only returns the first one.
!  */
! AttrNumber
! get_constraint_singlecol_attno(HeapTuple tup)
! {
! 	Datum	arrayp;
! 	bool	isnull;
! 	Datum  *keyvals;
! 	int		nelems;
! 
! 	arrayp = SysCacheGetAttr(CONSTROID, tup,
! 							 Anum_pg_constraint_conkey,
! 							 &isnull);
! 	if (isnull)
! 		elog(ERROR, "null conkey found");
  
! 	deconstruct_array(DatumGetArrayTypeP(arrayp), INT2OID, 2, true,
! 					  's', &keyvals, NULL, &nelems);
! 	if (nelems != 1)
! 		elog(ERROR, "constraint tuple has more than one key column");
  
! 	return DatumGetInt16(keyvals[0]);
! }
  
! /*
!  * RelationFetchNotNullConstraint
!  *
!  * Get (a copy of) the HeapTuple representing a NOT NULL constraint for the
!  * given relation and column, or NULL if there's no such constraint.
!  */
! HeapTuple
! RelationFetchNotNullConstraint(Relation pg_constraint, Oid relid,
! 							   AttrNumber attnum)
! {
! 	SysScanDesc	scan;
! 	ScanKeyData	key[1];
! 	HeapTuple	tup;
! 	bool		found;
  
! 	ScanKeyInit(&key[0],
! 				Anum_pg_constraint_conrelid,
! 				BTEqualStrategyNumber, F_OIDEQ,
! 				ObjectIdGetDatum(relid));
  
! 	scan = systable_beginscan(pg_constraint, ConstraintRelidIndexId, true,
! 							  SnapshotNow, 1, key);
  
! 	while (HeapTupleIsValid((tup = systable_getnext(scan))))
  	{
! 		Form_pg_constraint	conform = (Form_pg_constraint) GETSTRUCT(tup);
! 		AttrNumber		con_attno;
  
! 		if (conform->contype != CONSTRAINT_NOTNULL)
! 			continue;
  
! 		con_attno = get_constraint_singlecol_attno(tup);
  
! 		if (con_attno != attnum)
! 			continue;
! 
! 		tup = heap_copytuple(tup);
! 		found = true;
! 		break;
  	}
+ 	if (!found)
+ 		tup = NULL;
  
! 	systable_endscan(scan);
  
! 	return tup;
! }
! 
! /*
!  * GetRelationNotNullConstraints
!  *
!  * Return a list of not null constraints in a table, as a list of struct
!  * NotNullConstraint.
!  */
! List *
! GetRelationNotNullConstraints(Relation rel)
! {
! 	Relation		constr_rel;
! 	ScanKeyData		key;
! 	SysScanDesc		scan;
! 	HeapTuple		constr_tup;
! 	List		   *constraints = NIL;
! 	TupleDesc		tupdesc = RelationGetDescr(rel);
! 
! 	constr_rel = heap_open(ConstraintRelationId, AccessShareLock);
! 	ScanKeyInit(&key,
! 				Anum_pg_constraint_conrelid,
! 				BTEqualStrategyNumber, F_OIDEQ,
! 				ObjectIdGetDatum(RelationGetRelid(rel)));
! 	scan = systable_beginscan(constr_rel, ConstraintRelidIndexId,
! 							  true, SnapshotNow, 1, &key);
! 	while (HeapTupleIsValid(constr_tup = systable_getnext(scan)))
! 	{
! 		Form_pg_constraint	constr;
! 		int					attnum;
! 		Form_pg_attribute	attr;
! 		NotNullConstraint  *constraint;
! 
! 		constr = (Form_pg_constraint) GETSTRUCT(constr_tup);
! 
! 		if (constr->contype != CONSTRAINT_NOTNULL)
! 			continue;
! 
! 		attnum = get_constraint_singlecol_attno(constr_tup);
! 		attr = tupdesc->attrs[attnum - 1];
  
! 		constraint = (NotNullConstraint *) palloc(sizeof(NotNullConstraint));
! 		constraint->conname = pstrdup(NameStr(constr->conname));
! 		constraint->attname = pstrdup(NameStr(attr->attname));
! 		constraint->attnum = attnum;
! 		constraint->is_local = constr->conislocal;
! 		constraint->inhcount = constr->coninhcount;
  
! 		constraints = lappend(constraints, constraint);
  	}
  
! 	systable_endscan(scan);
! 	heap_close(constr_rel, AccessShareLock);
! 
! 	return constraints;
  }
  
  /*
!  * CreateOrAdjustNotNullConstraint
!  *
!  * Create a new NOT NULL constraint for the given relation and attnum, if
!  * none exists already; otherwise, adjust its properties by adding the given
!  * quantity to coninhcount, and tweak conislocal as follows: set to true if
!  * tweak_islocal is positive, to false if negative, or not at all if 0.
!  */
! void
! CreateOrAdjustNotNullConstraint(Relation rel, AttrNumber attnum, char *attname,
! 								int addinhcount, int tweak_islocal)
! {
! 	HeapTuple	constrtup;
! 	Relation	pg_con;
! 
! 	pg_con = heap_open(ConstraintRelationId, RowExclusiveLock);
! 
! 	constrtup = RelationFetchNotNullConstraint(pg_con, RelationGetRelid(rel),
! 											   attnum);
! 	if (constrtup)
! 	{
! 		HeapTuple	copy_con = heap_copytuple(constrtup);
! 		Form_pg_constraint conform = (Form_pg_constraint) GETSTRUCT(copy_con);
! 
! 		conform->coninhcount += addinhcount;
! 		if (tweak_islocal > 0)
! 			conform->conislocal = true;
! 		else if (tweak_islocal < 0)
! 			conform->conislocal = false;
! 
! 		simple_heap_update(pg_con, &(copy_con->t_self), copy_con);
! 		CatalogUpdateIndexes(pg_con, copy_con);
! 	}
! 	else
! 	{
! 		CreateNotNullConstraint(rel, attnum, NULL, 1, false);
! 	}
! 
! 	heap_close(pg_con, RowExclusiveLock);
! }
! 
! 
! /*
!  * ALTER TABLE SET WITH OIDS
!  *
!  * Basically this is an ADD COLUMN for the special OID column.	We have
!  * to cons up a ColumnDef node because the ADD COLUMN code needs one.
   */
  static void
! ATPrepAddOids(List **wqueue, Relation rel, bool recurse, AlterTableCmd *cmd, LOCKMODE lockmode)
! {
! 	/* If we're recursing to a child table, the ColumnDef is already set up */
! 	if (cmd->def == NULL)
! 	{
! 		ColumnDef  *cdef = makeNode(ColumnDef);
! 
! 		cdef->colname = pstrdup("oid");
! 		cdef->typeName = makeTypeNameFromOid(OIDOID, -1);
! 		cdef->inhcount = 0;
! 		cdef->is_local = true;
! 		cdef->is_not_null = true;
! 		cdef->storage = 0;
! 		cmd->def = (Node *) cdef;
! 	}
! 	ATPrepAddColumn(wqueue, rel, recurse, false, cmd, lockmode);
! 
! 	if (recurse)
! 		cmd->subtype = AT_AddOidsRecurse;
! }
! 
! /*
!  * ALTER TABLE ALTER COLUMN DROP NOT NULL
!  *
!  * For inheritance children, the consequences are nonobvious: if we're asked
!  * to recurse, we have to recurse to delete the constraint from them too.  If
!  * we're asked not to recurse, we have to recurse anyway, but instead of
!  * deleting we need to decrement the coninhcount for the constraint, and set
!  * conislocal if inhcount goes to zero.
!  */
! static bool
! ATExecDropNotNull(Relation rel, const char *colName,
! 				  bool recurse, bool recursing, LOCKMODE lockmode)
! {
! 	List	   *children;
! 	ListCell   *child;
! 	Oid			relid;
! 	HeapTuple   attrtup;
! 	HeapTuple   constrtup;
! 	Relation    pg_attr;
! 	Relation    pg_con;
! 	Form_pg_attribute attrform;
! 	Form_pg_constraint constrform;
! 	bool		do_drop;
! 	bool		retval = false;
! 
! 	/* At top level, permission check was done in ATPrepCmd, else do it */
! 	if (recursing)
! 		ATSimplePermissions(rel, ATT_TABLE | ATT_FOREIGN_TABLE);
! 
! 	relid = RelationGetRelid(rel);
! 	children = find_inheritance_children(relid, lockmode);
! 
! 	/* lookup the pg_attribute row */
! 	pg_attr = heap_open(AttributeRelationId, RowExclusiveLock);
! 	attrtup = SearchSysCacheCopyAttName(relid, colName);
! 
! 	if (!HeapTupleIsValid(attrtup))
! 		ereport(ERROR,
! 				(errcode(ERRCODE_UNDEFINED_COLUMN),
! 				 errmsg("column \"%s\" of relation \"%s\" does not exist",
! 						colName, RelationGetRelationName(rel))));
! 
! 	attrform = (Form_pg_attribute) GETSTRUCT(attrtup);
! 
! 	/* Prevent them from altering a system attribute */
! 	if (attrform->attnum <= 0)
! 		ereport(ERROR,
! 				(errcode(ERRCODE_FEATURE_NOT_SUPPORTED),
! 				 errmsg("cannot alter system column \"%s\"", colName)));
! 
! 	/* Easy case: if attnotnull is not set, there's nothing to do */
! 	if (!attrform->attnotnull)
! 	{
! 		heap_freetuple(attrtup);
! 		heap_close(pg_attr, RowExclusiveLock);
! 		return false;
! 	}
! 
! 	/*
! 	 * Look up the pg_constraint row.  If there's none, then the attnotnull
! 	 * mark is due to a primary key, and we must not touch it.
! 	 *
! 	 * XXX We could, but do not, attempt to locate the pg_constraint row for
! 	 * the primary key, to ensure that what our message says is true.
! 	 */
! 	pg_con = heap_open(ConstraintRelationId, RowExclusiveLock);
! 	constrtup = RelationFetchNotNullConstraint(pg_con, relid, attrform->attnum);
! 	if (!constrtup)
! 		ereport(ERROR,
! 				(errcode(ERRCODE_INVALID_TABLE_DEFINITION),
! 				 errmsg("column \"%s\" is in a primary key", colName)));
! 
! 	constrform = (Form_pg_constraint) GETSTRUCT(constrtup);
! 	
! 	/*
! 	 * Finally, figure out if we're to actually drop the constraint or not.  If
! 	 * this is the relation for which we were directly called, we need to
! 	 * forbid dropping the constraint if it's inherited; they need to drop it
! 	 * from the parent instead.
! 	 *
! 	 * On the other hand, if we're recursing, we actually drop the constraint
! 	 * only if it's not locally defined and there are no other parents forcing
! 	 * this constraint, *and* we're asked to recurse.  Otherwise, just update
! 	 * the pg_constraint tuple: decrement coninhcount in all cases, and if not
! 	 * asked to recurse we need to set conislocal to true in case it goes to
! 	 * zero.  Otherwise (i.e. inhcount is zero and we're asked to recurse), do
! 	 * drop the contraint.
! 	 */
! 	do_drop = false;
! 	if (!recursing)
! 	{
! 		if (constrform->coninhcount != 0)
! 			ereport(ERROR,
! 					(errcode(ERRCODE_INVALID_TABLE_DEFINITION),
! 					 errmsg("cannot drop inherited NOT NULL constraint \"%s\", relation \"%s\"",
! 							NameStr(constrform->conname), RelationGetRelationName(rel))));
! 		do_drop = true;
! 	}
! 	else
! 	{
! 		bool	do_update = false;
! 
! 		if (--constrform->coninhcount == 0 && !constrform->conislocal)
! 		{
! 			if (!recurse && recursing)
! 			{
! 				constrform->conislocal = true;
! 				do_update = true;
! 			}
! 			else
! 				do_drop = true;
! 		}
! 		else
! 			do_update = true;
! 
! 		if (do_update)
! 		{
! 			Assert(!do_drop);
! 			simple_heap_update(pg_con, &(constrtup->t_self), constrtup);
! 			CatalogUpdateIndexes(pg_con, constrtup);
! 
! 			retval = true;
! 		}
! 	}
! 
! 	/*
! 	 * Okay, delete the constraint.  Note that we mustn't update pg_attribute
! 	 * if there's a PK involving the column.
! 	 */
! 	if (do_drop)
! 	{
! 		ObjectAddress	conobj;
! 		HeapTuple	pktup;
! 		bool		ispk;
! 		SysScanDesc	scan;
! 		ScanKeyData	key[1];
! 
! 		conobj.classId = ConstraintRelationId;
! 		conobj.objectId = HeapTupleGetOid(constrtup);
! 		conobj.objectSubId = 0;
! 
! 		performDeletion(&conobj, DROP_CASCADE);
! 
! 		ScanKeyInit(&key[0],
! 					Anum_pg_constraint_conrelid,
! 					BTEqualStrategyNumber, F_OIDEQ,
! 					ObjectIdGetDatum(relid));
! 
! 		scan = systable_beginscan(pg_con, ConstraintRelidIndexId,
! 								  true, SnapshotNow, 1, key);
! 		ispk = false;
! 		while (HeapTupleIsValid(pktup = systable_getnext(scan)))
! 		{
! 			Form_pg_constraint	pkform;
! 			Datum	arrayp;
! 			Datum  *keyvals;
! 			int		nelems;
! 			bool	isnull;
! 			int		i;
! 
! 			pkform = (Form_pg_constraint) GETSTRUCT(pktup);
! 			if (pkform->contype != CONSTRAINT_PRIMARY)
! 				continue;
! 
! 			arrayp = SysCacheGetAttr(CONSTROID, pktup,
! 									 Anum_pg_constraint_conkey,
! 									 &isnull);
! 			if (isnull)
! 				elog(ERROR, "null conkey found");
! 
! 			deconstruct_array(DatumGetArrayTypeP(arrayp), INT2OID, 2, true,
! 							  's', &keyvals, NULL, &nelems);
! 			for (i = 0; i < nelems; i++)
! 			{
! 				if (DatumGetInt16(keyvals[i]) == attrform->attnum)
! 				{
! 					ispk = true;
! 					break;
! 				}
! 			}
! 			if (ispk)
! 				break;
! 		}
! 		systable_endscan(scan);
! 
! 		/* it's not PK -- reset attnotnull */
! 		if (!ispk)
! 		{
! 			attrform->attnotnull = false;
! 			simple_heap_update(pg_attr, &(attrtup->t_self), attrtup);
! 			CatalogUpdateIndexes(pg_attr, attrtup);
! 		}
! 
! 		/*
! 		 * Perform work on all children, if any.  Note that if a children is
! 		 * altered during recursion, we need a CommandCounterIncrement, as in
! 		 * ATExecSetNotNull; see comments therein.  (This is only necessary in
! 		 * case we update pg_constraint, though; if we do a delete there, or in
! 		 * case we update pg_attribute, there's no need for this.)
! 		 */
! 		foreach(child, children)
! 		{
! 			Oid childrelid = lfirst_oid(child);
! 			Relation childrel;
! 
! 			Assert(!recursing || recurse);
! 
! 			/* find_inheritance_children already got lock */
! 			childrel = heap_open(childrelid, NoLock);
! 			CheckTableNotInUse(childrel, "ALTER TABLE");
! 
! 			if (ATExecDropNotNull(childrel, colName, recurse, true, lockmode))
! 				CommandCounterIncrement();
! 
! 			heap_close(childrel, NoLock);
! 		}
! 	}
! 
! 	heap_close(pg_con, RowExclusiveLock);
! 	heap_close(pg_attr, RowExclusiveLock);
! 
! 	return retval;
! }
! 
! /*
!  * ALTER TABLE ALTER COLUMN SET NOT NULL
!  *
!  * Recursively add not null constraints to the given relation and column name.
!  * If the constraint is inherited, walk down the inheritance tree to ensure the
!  * inheritance counter for each not null constraint is adjusted accordingly.
!  */
! static bool
! ATExecSetNotNull(List **wqueue, AlteredTableInfo *tab, Relation rel,
! 				 const char *colName, bool recurse, bool recursing,
! 				 LOCKMODE lockmode)
  {
  	HeapTuple	tuple;
  	AttrNumber	attnum;
  	Relation	attr_rel;
+ 	Oid			relid;
+ 	List       *children;
+ 	ListCell   *cell;
+ 	Relation	pg_con;
+ 	HeapTuple	constrtup;
+ 	Form_pg_attribute	attrtup;
+ 
+ 	/* At top level, permission check was done in ATPrepCmd, else do it */
+ 	if (recursing)
+ 		ATSimplePermissions(rel, ATT_TABLE | ATT_FOREIGN_TABLE);
  
  	/*
! 	 * We only recurse one level at a time, because if we merge a constraint
! 	 * with an existing one in a child, we have to stop recursing down that
! 	 * hierarchy path.
  	 */
+ 	children = find_inheritance_children(RelationGetRelid(rel),
+ 										 lockmode);
+ 
+ 	/* lookup the attribute */
  	attr_rel = heap_open(AttributeRelationId, RowExclusiveLock);
  
! 	relid = RelationGetRelid(rel);
! 	tuple = SearchSysCacheCopyAttName(relid, colName);
  
  	if (!HeapTupleIsValid(tuple))
  		ereport(ERROR,
***************
*** 4709,4742 **** ATExecSetNotNull(AlteredTableInfo *tab, Relation rel,
  				 errmsg("column \"%s\" of relation \"%s\" does not exist",
  						colName, RelationGetRelationName(rel))));
  
! 	attnum = ((Form_pg_attribute) GETSTRUCT(tuple))->attnum;
  
  	/* Prevent them from altering a system attribute */
  	if (attnum <= 0)
  		ereport(ERROR,
  				(errcode(ERRCODE_FEATURE_NOT_SUPPORTED),
! 				 errmsg("cannot alter system column \"%s\"",
! 						colName)));
  
  	/*
! 	 * Okay, actually perform the catalog change ... if needed
  	 */
! 	if (!((Form_pg_attribute) GETSTRUCT(tuple))->attnotnull)
  	{
! 		((Form_pg_attribute) GETSTRUCT(tuple))->attnotnull = TRUE;
  
! 		simple_heap_update(attr_rel, &tuple->t_self, tuple);
  
! 		/* keep the system catalog indexes current */
! 		CatalogUpdateIndexes(attr_rel, tuple);
  
! 		/* Tell Phase 3 it needs to test the constraint */
! 		tab->new_notnull = true;
  	}
  
  	heap_close(attr_rel, RowExclusiveLock);
  }
  
  /*
   * ALTER TABLE ALTER COLUMN SET/DROP DEFAULT
   */
--- 5538,5732 ----
  				 errmsg("column \"%s\" of relation \"%s\" does not exist",
  						colName, RelationGetRelationName(rel))));
  
! 	attrtup = (Form_pg_attribute) GETSTRUCT(tuple);
! 	attnum = attrtup->attnum;
  
  	/* Prevent them from altering a system attribute */
  	if (attnum <= 0)
  		ereport(ERROR,
  				(errcode(ERRCODE_FEATURE_NOT_SUPPORTED),
! 				 errmsg("cannot alter system column \"%s\" of relation \"%s\"",
! 						colName, RelationGetRelationName(rel))));
! 
! 	/*
! 	 * If we are told not to recurse, there had better not be any child
! 	 * tables; else the addition would put them out of step.
! 	 */
! 	if (children && !recurse)
! 		ereport(ERROR,
! 				(errcode(ERRCODE_INVALID_TABLE_DEFINITION),
! 				 errmsg("NOT NULL constraint must be added to child tables too")));
! 
! 	pg_con = heap_open(ConstraintRelationId, RowExclusiveLock);
! 	constrtup = RelationFetchNotNullConstraint(pg_con, relid, attnum);
! 
! 	/*
! 	 * At the top level of recursion, an existing constraint means we only need
! 	 * to set conislocal (if not set already).  If we're already recursing,
! 	 * however, we need to adjust attinhcount.  In both cases we stop
! 	 * recursing, because the children must already have this constraint.
! 	 */
! 	if (constrtup)
! 	{
! 		Form_pg_constraint	constrform;
! 		bool			touched = false;
! 
! 		constrform = (Form_pg_constraint) GETSTRUCT(constrtup);
! 
! 		if (!recursing)
! 		{
! 			if (!constrform->conislocal)
! 			{
! 				constrform->conislocal = true;
! 				touched = true;
! 			}
! 		}
! 		else
! 		{
! 			constrform->coninhcount++;
! 			touched = true;
! 		}
! 
! 		if (touched)
! 		{
! 			simple_heap_update(pg_con, &(constrtup->t_self), constrtup); 
! 			CatalogUpdateIndexes(pg_con, constrtup);
! 		}
! 
! 		heap_close(pg_con, RowExclusiveLock);
! 		heap_close(attr_rel, RowExclusiveLock);
! 
! 		return touched;
! 	}
! 
! 	/*
! 	 * By here, we've established that the column does not already have a not
! 	 * null constraint, so we need to add one and recurse to ensure that our
! 	 * children have it too.
! 	 */
! 	CreateNotNullConstraint(rel, attnum, NULL,
! 							recursing ? 1 : 0,
! 							recursing ? false : true);
! 
! 	/*
! 	 * And set attnotnull in pg_attribute.  Note that it might already be set,
! 	 * if the column belongs to a primary key.
! 	 */
! 	if (!attrtup->attnotnull)
! 	{
! 		HeapTuple	copy_attr = heap_copytuple(tuple);
! 		Form_pg_attribute attrform = (Form_pg_attribute) GETSTRUCT(copy_attr);
! 
! 		attrform->attnotnull = true;
! 
! 		simple_heap_update(attr_rel, &(copy_attr->t_self), copy_attr);
! 		CatalogUpdateIndexes(attr_rel, copy_attr);
! 	}
! 
! 	/* Tell Phase 3 it needs to test the constraint */
! 	tab->new_notnull = true;
! 
! 	heap_close(attr_rel, RowExclusiveLock);
! 	heap_close(pg_con, RowExclusiveLock);
  
  	/*
! 	 * Recurse.  Note that if a child is altered during recursion, we need
! 	 * a CommandCounterIncrement in case that table is also a direct child
! 	 * of our parent.  (Skipping that would mean that we would try to update
! 	 * its pg_constraint and pg_attribute rows twice without an intervening
! 	 * CCI, leading to "tuple updated by self").  Maybe there's a way to avoid
! 	 * this overhead by building a table of coninhcount increments we need to
! 	 * apply to each relation before actually applying them, but it doesn't
! 	 * seem worth the trouble (and it doesn't help with pg_attribute updates
! 	 * anyway.)
  	 */
! 	foreach(cell, children)
  	{
! 		Oid			childrelid = lfirst_oid(cell);
! 		Relation	childrel;
! 		AlteredTableInfo *childtab;
! 
! 		/* find_inheritance_children already got lock */
! 		childrel = heap_open(childrelid, NoLock);
! 		CheckTableNotInUse(childrel, "ALTER TABLE");
! 
! 		/* get work queue entry for child relation */
! 		childtab = ATGetQueueEntry(wqueue, childrel);
! 
! 		/* perform the actual work */
! 		if (ATExecSetNotNull(wqueue, childtab, childrel,
! 							 colName, recurse, true,
! 							 lockmode))
! 			CommandCounterIncrement();
! 
! 		heap_close(childrel, NoLock);
! 	}
! 
! 	return true;
! }
! 
! /*
!  * ATExecSetAttNotNull
!  *
!  * This is not SQL-accessible directly -- it's only used by DefineIndex to
!  * ensure that pg_attribute.attnotnull is set for PRIMARY KEY columns.  The
!  * differences with plain SET NOT NULL is that we don't create pg_constraint
!  * entries, and we do not recurse either.
!  */
! static void
! ATExecSetAttNotNull(List **wqueue, AlteredTableInfo *tab, Relation rel,
! 				 const char *colName, LOCKMODE lockmode)
! {
! 	Relation	attr_rel;
! 	Oid			relid;
! 	HeapTuple	tuple;
! 	Form_pg_attribute	attrtup;
! 	AttrNumber	attnum;
! 
! 	/* lookup the attribute */
! 	attr_rel = heap_open(AttributeRelationId, RowExclusiveLock);
! 
! 	relid = RelationGetRelid(rel);
! 	tuple = SearchSysCacheCopyAttName(relid, colName);
! 
! 	if (!HeapTupleIsValid(tuple))
! 		ereport(ERROR,
! 				(errcode(ERRCODE_UNDEFINED_COLUMN),
! 				 errmsg("column \"%s\" of relation \"%s\" does not exist",
! 						colName, RelationGetRelationName(rel))));
  
! 	attrtup = (Form_pg_attribute) GETSTRUCT(tuple);
! 	attnum = attrtup->attnum;
! 
! 	/* Prevent them from altering a system attribute */
! 	if (attnum <= 0)
! 		ereport(ERROR,
! 				(errcode(ERRCODE_FEATURE_NOT_SUPPORTED),
! 				 errmsg("cannot alter system column \"%s\" of relation \"%s\"",
! 						colName, RelationGetRelationName(rel))));
! 
! 	/*
! 	 * And set attnotnull in pg_attribute.  Note that it might already be set,
! 	 * if the column has a NOT NULL constraint already.
! 	 */
! 	if (!attrtup->attnotnull)
! 	{
! 		HeapTuple	copy_attr = heap_copytuple(tuple);
! 		Form_pg_attribute attrform = (Form_pg_attribute) GETSTRUCT(copy_attr);
  
! 		attrform->attnotnull = true;
  
! 		simple_heap_update(attr_rel, &(copy_attr->t_self), copy_attr);
! 		CatalogUpdateIndexes(attr_rel, copy_attr);
  	}
  
+ 	/* Tell Phase 3 it needs to test the constraint */
+ 	tab->new_notnull = true;
+ 
  	heap_close(attr_rel, RowExclusiveLock);
  }
  
+ 
  /*
   * ALTER TABLE ALTER COLUMN SET/DROP DEFAULT
   */
